/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.utils;

import static org.assertj.core.api.Assertions.assertThat;

import java.util.ArrayList;
import java.util.Collections;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInstance;

@TestInstance(TestInstance.Lifecycle.PER_CLASS)
class NaturalOrderComparatorTest {
    private ArrayList<String> original;
    private ArrayList<String> toCompare;
    private ArrayList<String> lexicographic;
    private ArrayList<String> natural;

    @BeforeAll
    void setUp(){
        original = new ArrayList<>();
        original.add("1");
        original.add("10");
        original.add("100");
        original.add("3");
        original.add("101");
        original.add("10000");
        original.add("100000");

        toCompare = new ArrayList<>(original);

        lexicographic = new ArrayList<>();
        lexicographic.add("1");
        lexicographic.add("10");
        lexicographic.add("100");
        lexicographic.add("101");
        lexicographic.add("10000");
        lexicographic.add("100000");
        lexicographic.add("3");

        natural = new ArrayList<>();
        natural.add("1");
        natural.add("3");
        natural.add("10");
        natural.add("100");
        natural.add("101");
        natural.add("10000");
        natural.add("100000");

        Collections.shuffle(toCompare);
    }

    @Test
    void testIfArraySortIsCorrect(){
        NaturalOrderComparator comparator = new NaturalOrderComparator();
        toCompare.sort(comparator);

        assertThat(toCompare)
            .containsSequence(natural)
            .doesNotContainSequence(lexicographic)
            .doesNotContainSequence(original);

    }
}